[atk/ci-docker] Add CI pipeline for ATK



commit 13ee2315917f8df8d2ae26d92515f4aa3bdf0641
Author: Emmanuele Bassi <ebassi gnome org>
Date:   Mon Apr 20 16:40:50 2020 +0100

    Add CI pipeline for ATK
    
    Use the GitLab CI support to build ATK, so we can at least be confident
    that we're not breaking stuff with every commit.

 .gitlab-ci.yml                      |  67 ++++++++++++++++++
 .gitlab-ci/debian-stable.Dockerfile |  42 +++++++++++
 .gitlab-ci/fedora-latest.Dockerfile |  37 ++++++++++
 .gitlab-ci/run-docker.sh            | 135 ++++++++++++++++++++++++++++++++++++
 .gitlab-ci/setup-build-docker.sh    |  12 ++++
 5 files changed, 293 insertions(+)
---
diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
new file mode 100644
index 0000000..5007263
--- /dev/null
+++ b/.gitlab-ci.yml
@@ -0,0 +1,67 @@
+stages:
+  - build
+  - docs
+  - deploy
+
+cache:
+  paths:
+    - _ccache/
+
+# Common variables
+variables:
+  COMMON_MESON_FLAGS: "--fatal-meson-warnings --werror"
+  MESON_TEST_TIMEOUT_MULTIPLIER: 2
+
+.default-build:
+  script:
+    - .gitlab-ci/setup-docker-build.sh
+    - ninja -C _build
+  artifacts:
+    when: always
+    name: "atk-${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}"
+    paths:
+      - "_build/meson-logs"
+
+gnome-runtime-latest:
+  extends: .default-build
+  stage: build
+  image: registry.gitlab.gnome.org/gnome/gnome-runtime-images/gnome:3.36
+  variables:
+    EXTRA_MESON_FLAGS: "-Ddefault_library=both"
+
+fedora-latest:
+  extends: .default-build
+  stage: build
+  image: registry.gitlab.gnome.org/gnome/atk/fedora-latest:v1
+  variables:
+    EXTRA_MESON_FLAGS: "-Ddefault_library=both"
+
+debian-stable:
+  extends: .default-build
+  stage: build
+  image: registry.gitlab.gnome.org/gnome/atk/debian-stable:v1
+  variables:
+    EXTRA_MESON_FLAGS: "-Ddefault_library=both"
+
+reference:
+  image: registry.gitlab.gnome.org/gnome/gtk/fedora-latest:v1
+  stage: docs
+  variables:
+    EXTRA_MESON_FLAGS: "--buildtype=release -Dgtk_doc=true"
+  script:
+    - .gitlab-ci/setup-docker-build.sh
+    - ninja -C _build atk-doc
+    - mv _build/docs/html _reference
+  artifacts:
+    paths:
+      - _reference
+
+pages:
+  stage: deploy
+  script:
+    - mv _reference/ public/
+  artifacts:
+    paths:
+      - public
+  only:
+    - master
diff --git a/.gitlab-ci/debian-stable.Dockerfile b/.gitlab-ci/debian-stable.Dockerfile
new file mode 100644
index 0000000..04f70a4
--- /dev/null
+++ b/.gitlab-ci/debian-stable.Dockerfile
@@ -0,0 +1,42 @@
+FROM debian:buster
+
+RUN apt-get update -qq && apt-get install --no-install-recommends -qq -y \
+    ccache \
+    dconf-gsettings-backend \
+    g++ \
+    gcc \
+    gettext \
+    git \
+    gobject-introspection \
+    itstool \
+    libc6-dev \
+    libgirepository1.0-dev \
+    libglib2.0-dev \
+    libwayland-dev \
+    libx11-dev \
+    libxml2-dev \
+    libxrandr-dev \
+    locales \
+    ninja-build \
+    pkg-config \
+    python3 \
+    python3-pip \
+    python3-setuptools \
+    python3-wheel \
+    shared-mime-info \
+    wayland-protocols \
+    xauth \
+    xvfb \
+ && rm -rf /usr/share/doc/* /usr/share/man/*
+
+# Locale for our build
+RUN locale-gen C.UTF-8 && /usr/sbin/update-locale LANG=C.UTF-8
+
+ARG HOST_USER_ID=5555
+ENV HOST_USER_ID ${HOST_USER_ID}
+RUN useradd -u $HOST_USER_ID -ms /bin/bash user
+
+USER user
+WORKDIR /home/user
+
+ENV LANG=C.UTF-8 LANGUAGE=C.UTF-8 LC_ALL=C.UTF-8
diff --git a/.gitlab-ci/fedora-latest.Dockerfile b/.gitlab-ci/fedora-latest.Dockerfile
new file mode 100644
index 0000000..42ddf03
--- /dev/null
+++ b/.gitlab-ci/fedora-latest.Dockerfile
@@ -0,0 +1,37 @@
+FROM fedora:31
+
+RUN dnf -y install \
+    at-spi2-atk-devel \
+    ccache \
+    dbus-x11 \
+    gcc \
+    gcc-c++ \
+    gettext \
+    gettext-devel \
+    git \
+    glib2-devel \
+    gobject-introspection-devel \
+    gtk-doc \
+    iso-codes \
+    itstool \
+    make \
+    meson \
+    ninja-build \
+    python3 \
+    python3-pip \
+    python3-wheel \
+    redhat-rpm-config \
+    wayland-devel \
+    wayland-protocols-devel \
+    xorg-x11-server-Xvfb \
+    && dnf clean all
+
+ARG HOST_USER_ID=5555
+ENV HOST_USER_ID ${HOST_USER_ID}
+RUN useradd -u $HOST_USER_ID -ms /bin/bash user
+
+USER user
+WORKDIR /home/user
+
+ENV LANG C.utf8
+ENV PATH="/usr/lib64/ccache:${PATH}"
diff --git a/.gitlab-ci/run-docker.sh b/.gitlab-ci/run-docker.sh
new file mode 100755
index 0000000..618ddd9
--- /dev/null
+++ b/.gitlab-ci/run-docker.sh
@@ -0,0 +1,135 @@
+#!/bin/bash
+
+read_arg() {
+    # $1 = arg name
+    # $2 = arg value
+    # $3 = arg parameter
+    local rematch='^[^=]*=(.*)$'
+    if [[ $2 =~ $rematch ]]; then
+        read "$1" <<< "${BASH_REMATCH[1]}"
+    else
+        read "$1" <<< "$3"
+        # There is no way to shift our callers args, so
+        # return 1 to indicate they should do it instead.
+        return 1
+    fi
+}
+
+set -e
+
+build=0
+run=0
+push=0
+list=0
+print_help=0
+no_login=0
+
+while (($# > 0)); do
+        case "${1%%=*}" in
+                build) build=1;;
+                run) run=1;;
+                push) push=1;;
+                list) list=1;;
+                help) print_help=1;;
+                --base|-b) read_arg base "$@" || shift;;
+                --base-version) read_arg base_version "$@" || shift;;
+                --no-login) no_login=1;;
+                *) echo -e "\e[1;31mERROR\e[0m: Unknown option '$1'"; exit 1;;
+        esac
+        shift
+done
+
+if [ $print_help == 1 ]; then
+        echo "$0 - Build and run Docker images"
+        echo ""
+        echo "Usage: $0 <command> [options] [basename]"
+        echo ""
+        echo "Available commands"
+        echo ""
+        echo "  build --base=<BASENAME> - Build Docker image <BASENAME>.Dockerfile"
+        echo "  run --base=<BASENAME>   - Run Docker image <BASENAME>"
+        echo "  push --base=<BASENAME>  - Push Docker image <BASENAME> to the registry"
+        echo "  list                    - List available images"
+        echo "  help                    - This help message"
+        echo ""
+        exit 0
+fi
+
+cd "$(dirname "$0")"
+
+if [ $list == 1 ]; then
+        echo "Available Docker images:"
+        for f in *.Dockerfile; do
+                filename=$( basename -- "$f" )
+                basename="${filename%.*}"
+
+                echo -e "  \e[1;39m$basename\e[0m"
+        done
+        exit 0
+fi
+
+# All commands after this require --base to be set
+if [ -z $base ]; then
+        echo "Usage: $0 <command>"
+        exit 1
+fi
+
+if [ ! -f "$base.Dockerfile" ]; then
+        echo -e "\e[1;31mERROR\e[0m: Dockerfile for '$base' not found"
+        exit 1
+fi
+
+if [ -z $base_version ]; then
+        base_version="latest"
+else
+        base_version="v$base_version"
+fi
+
+if [ ! -x "$(command -v docker)" ] || [ docker --help |& grep -q podman ]; then
+        # Docker is actually implemented by podman, and its OCI output
+        # is incompatible with some of the dockerd instances on GitLab
+        # CI runners.
+        echo "Using: Podman"
+        format="--format docker"
+        CMD="podman"
+else
+        echo "Using: Docker"
+        format=""
+        CMD="sudo socker"
+fi
+
+REGISTRY="registry.gitlab.gnome.org"
+TAG="${REGISTRY}/gnome/atk/${base}:${base_version}"
+
+if [ $build == 1 ]; then
+        echo -e "\e[1;32mBUILDING\e[0m: ${base} as ${TAG}"
+        ${CMD} build \
+                ${format} \
+                --build-arg HOST_USER_ID="$UID" \
+                --tag "${TAG}" \
+                --file "${base}.Dockerfile" .
+        exit $?
+fi
+
+if [ $push == 1 ]; then
+        echo -e "\e[1;32mPUSHING\e[0m: ${base} as ${TAG}"
+
+        if [ $no_login == 0 ]; then
+                ${CMD} login ${REGISTRY}
+        fi
+
+        ${CMD} push ${TAG}
+        exit $?
+fi
+
+if [ $run == 1 ]; then
+        echo -e "\e[1;32mRUNNING\e[0m: ${base} as ${TAG}"
+        ${CMD} run \
+                --rm \
+                --volume "$(pwd)/..:/home/user/app" \
+                --workdir "/home/user/app" \
+                --tty \
+                --interactive "${TAG}" \
+                bash
+        exit $?
+fi
diff --git a/.gitlab-ci/setup-build-docker.sh b/.gitlab-ci/setup-build-docker.sh
new file mode 100755
index 0000000..08b7fcb
--- /dev/null
+++ b/.gitlab-ci/setup-build-docker.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+set -e
+
+mkdir -p _ccache
+export CCACHE_BASEDIR="$(pwd)"
+export CCACHE_DIR="${CCACHE_BASEDIR}/_ccache"
+
+export PATH="${HOME}/.local/bin:${PATH}"
+python3 -m pip install --user meson==0.49.2
+
+meson ${EXTRA_MESON_FLAGS:-} _build .


[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]